﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Web
{
    public abstract class TemplateBase : IDisposable
    {
        //内部 text writer
        public TextWriter Writer;

        public TemplateBase()
        {
            Writer = new StringWriter();
        }

        public abstract void Execute();
        public virtual void Write(object value)
        {
            Writer.Write(value);
        }
        public virtual void WriteLiteral(object value)
        {
            Writer.Write(value);
        }

        //渲染
        public virtual string Render()
        {
            return Writer.ToString();
        }

        public virtual void Dispose()
        {
            Writer.Close();
        }
    }
}
